// -*- tab-width: 4 -*-

/* Directi Pvt. Ltd. 2011 */

// The email plugin for chirkut.js


var emailjs = require('emailjs');
var us      = require('underscore');
var nxb     = require('node-xmpp-bosh');
var dutil   = nxb.dutil;
var us      = require('underscore');


var SMTP_HOST     = 'smtp.directi.com';
var SMTP_PORT     = 25;
var SMTP_USERNAME = 'boshserver@directi.com';
var SMTP_PASSWORD = 'lB@BHjp2';

var OFFLINE_MESSAGES_EMAIL_FROM = 'Offline Messages<offline.messages+no-reply@directi.com>';
var MESSAGE_MISSED_SUBJECT = 'talk.to: Offline messages';


function send_email(from, to, subject, text, cb) {
    var server = emailjs.server.connect({
        host: SMTP_HOST,
        port: SMTP_PORT,
        username: SMTP_USERNAME,
        password: SMTP_PASSWORD
    });

    var message = emailjs.message.create({
        to: to,
        from: from,
        subject: subject,
        text: text
    });

    server.send(message, function(err, result) {
        // console.error('Mailer callback:', err, result);
        cb(err, message);
    });
}


var orphan_responses = { };
var server = null;


function extract_text_from_node(node) {
	var text = [ ];
	node.children.forEach(function(c) {
		if (us.isString(c)) {
			text.push(c);
		}
		else {
			text.push(extract_text_from_node(c));
		}
	});

	return us.flatten(text).join(' ');
}


function offline_messages_email_body(_or) {
	var msg_map = { };

	_or.responses.forEach(function(response) {
		var text = extract_text_from_node(response);

		if (!msg_map[response.attrs.from]) {
			msg_map[response.attrs.from] = [ ];
		}

		msg_map[response.attrs.from].push(text);
	});

	var _msg = '';

	for (var sender in msg_map) {
		_msg += (sender + " said:\n" + msg_map[sender].join('\n') + '\n\n');
	}

	return _msg;
}

function no_client_for_this_xml_stanza(response) {
	if (!response.attrs.to || !response.is('message')) {
		return;
	}

	var jid_parts = nxb.dutil.jid_parse(response.attrs.to);
	if (!jid_parts.username || !jid_parts.domain) {
		return;
	}

	var to_jid = jid_parts.username + "@" + jid_parts.domain;

	if (response.attrs.type != 'chat') {
		// Note: We don't handle 'groupchat' since we can't be sure who the
		// message is for. Technically, it _may_ be possible to figure it out
		// based on the SID/STREAM, but we don't bother in the name of
		// simplicity & convenience. Either ways, the chat server sends 
		// chat-room history. The same happens for 'chat' as well, but I think
		// 'chat' messages are more important.
		return;
	}

	var bodies = response.children.filter(function(inner) {
		return inner && (typeof inner.is == 'function') && inner.is('body');
	}).map(function(body) {
		body.attrs.type = response.attrs.type;

		var fparts = nxb.dutil.jid_parse(response.attrs.from);
		body.attrs.from = fparts.username + "@" + fparts.domain;

		return body;
	});

	function mail_out_missed_responses() {
		var msg  = 'Oops, you seem to have missed these messages:\n\n';
		var _msg = offline_messages_email_body(_or);
		var sig  = '--\nThanks!!\n-The Regents of talk.to\n';

		delete orphan_responses[to_jid];

		if (_msg.length === 0) {
			return;
		}


		send_email(OFFLINE_MESSAGES_EMAIL_FROM, to_jid, MESSAGE_MISSED_SUBJECT, 
				   msg + _msg + sig, 
				   function() { console.log("Email sent to:", to_jid); }
				  );

	}

	if (!orphan_responses[to_jid]) {
		orphan_responses[to_jid] = {
			email: to_jid, 
			timeout: null, 
			responses: [ ]
		};
	}

	var _or = orphan_responses[to_jid];
	_or.responses.push.apply(_or.responses, bodies);

	// console.log("Adding", bodies, "to orphan_responses for", to_jid);

	if (_or.timeout) {
		clearTimeout(_or.timeout);
	}
	_or.timeout = setTimeout(mail_out_missed_responses, 10000);
}


function handle_on_no_client(response) {
	// console.log("on_no_client:", response);
	response.children.forEach(function(stanza) {
		no_client_for_this_xml_stanza(stanza);
	});
}


function init_email() {
	server.on('no-client', handle_on_no_client);
}

function destroy_email() {
	server.removeListener('no-client', handle_on_no_client);
}

exports.init = function(ctor_args) {
	if (!ctor_args || !ctor_args.server) {
		throw new Error("You MUST set 'server' to the BOSH server instance");
	}
	server = ctor_args.server;

	init_email();

};

exports.destroy = function() {
	destroy_email();
};
