// -*- tab-width: 4 -*-

/* Directi Pvt. Ltd. 2011 */

// The login-booster plugin for chirkut.js

/* +------------------+
 * | General strategy |
 * +------------------+
 * 
 * We expect the client to send us the following packets up-front:
 * 
 * 1. <auth>
 * 2. <iq> - resource binding
 * 3. <iq> - session start
 * 
 * The BOSH server will (on behalf of the client) send them at 
 * appropriate times to the XMPP server. This will only work for
 * the PLAIN-PW-TOKEN (another example of product name 
 * infiltration that should not have happened) since it is not
 * challenge-response based. We could make it work for others if
 * we wanted to, but this is just v1.
 * 
 * To make it work for other services such as talk.google.com and
 * chat.facebook.com, the BOSH proxy needs to know exactly how to
 * perform authentication on such services and should have the 
 * user's credentials handy to be able to perform challenge-response
 * based authentication.
 * 
 * 
 */
var BoosterFilter = require(__dirname + '/login_booster/booster_filter');

var server = null;
var filter = null;
 
exports.init = function(ctor_args){
    if (!ctor_args || !ctor_args.server) {
        throw new Error("You MUST get 'server' set to the BOSH server instance");
    }
    server = ctor_args.server;
    filter = BoosterFilter(server);
    server.on('nodes', filter.nodes, 10);
    server.on('response', filter.response, 10);
};

exports.destroy = function(){
    server.removeListener('nodes', filter.nodes);
    server.removeListener('response', filter.response);
};


 
 
 
