var events = require("events");
var util   = require('util');
var ejs = require('ejs');
var fs = require('fs');
var _ = require('underscore');
var states = require(__dirname + '/states');

var BoosterClient = exports.BoosterClient = function(inputStanzas, publish, to){
    this._state = new states.PreAuth({input: inputStanzas, to: to});
    this._publish = publish;
    this._next();
}

util.inherits(BoosterClient, events.EventEmitter);

BoosterClient.prototype.consumes = function(stanza){
    var newState = this._state.changeUsing(stanza);
    if (!newState) return false;
    this._state = newState;
    if (this._state.done()) 
        this.emit('done', this._state.responseStanzas());
    else 
        this._next();
    return true;
};
    
BoosterClient.prototype._next = function() {
	if (this._state.shouldRestartStream()) 
		this.emit('stream-restart');
    else {
        var stanza;
        while(stanza = this._state.popStanza()){
    		this._publish(stanza);
        }
    }
}

BoosterClient.create = function(authStanza, publish, to) {
    return new BoosterClient(authStanza, publish, to);
} 
