app_root  = "/opt/chirkut/chirkut_node.js"
God.pid_file_directory = "/var/run/"
%w{10280}.each do |port|
    God.watch do |w|
        God.load "#{app_root}/current/scripts/contacts/*.god"
        w.transition(:up, :start) do |on|
            on.condition(:process_exits) do |c|
              c.notify = {:contacts => ['sysads' , 'developers'] , :priority => 1 , :category => 'product'}
            end
        end
        w.name     = "chirkut-#{port}"
        w.group    = 'chirkut'
        # Default monitoring interval 
        w.interval = 30.seconds
        w.start  = "env node #{app_root}/current/run-server.js --port=#{port} --config=#{app_root}/current/chirkut.conf.js"
        w.stop  = "ps auxx | grep chirkut.js  | grep 10280 | awk '{print $2}' | xargs"
        # Lets run it as deploy user 
        # w.uid = ENV['deploy']
        # Not running as daemon 
        # w.behavior(:clean_pid_file)
        w.log = '/var/log/chirkut/chirkut.log'
        w.err_log = '/var/log/chirkut/chirkut_err.log'
        w.dir = "#{app_root}/current/" 
        w.start_if do |start|
            start.condition(:process_running) do |c|
              c.interval = 5.seconds
              c.running = false
            end
        end
        w.restart_if do |restart|
            restart.condition(:memory_usage) do |c|
              c.above = 300.megabytes
              c.times = [3, 5] # 3 out of 5 intervals
            end
            restart.condition(:cpu_usage) do |c|
              c.above = 50.percent
              c.times = 5
            end
        end
        # lifecycle
        w.lifecycle do |on|
            on.condition(:flapping) do |c|
              c.to_state = [:start, :restart]
              c.times = 5
              c.within = 5.minute
              c.transition = :unmonitored
              c.retry_in = 10.minutes
              c.retry_times = 5
              c.retry_within = 2.hours
            end
        end 
    end
end
