require(__dirname + '/../test_utils');
var assert = require('assert');
var _ = require('underscore'); 
var states = require(__dirname + '/../../plugins/login_booster/states');

var authfailState = function() {
    return new states.AuthFail({
        input: _('talkto_auth').createNodes(),
        auth: _('auth_failure').createStanza()
    });
}

module.exports = {
    'it is done': function() {
        assert.ok(authfailState().done());
    },
    'it sends a single response stanza with a failure response': function() {
        var response = authfailState().responseStanzas();
        assert.equal(1, response.length);
        var stanza = _(response).head();
        assert.stanzaEqual({
            'failure': {
                '@xmlns': 'http://talk.to/x-failure',
                'reason': {
                    '#text': 'auth'
                }
            }}, stanza);
    },
    
    'popStanza should return undefined': function() {
        assert.isUndefined(authfailState().popStanza());
    },

	'it should not restart stream' : function() {
		assert.equal(false, authfailState().shouldRestartStream());
	},
	
    'it provides hints that there are network failures that caused an auth failure': _.to_be_implemented,
    
    'it provides a domain unknown message if lookup fails': _.to_be_implemented,
    
    'it incorporates the actual failure message inside': _.to_be_implemented



}