require(__dirname + '/../test_utils');
var assert = require('assert');
var _ = require('underscore'); 
var states = require(__dirname + '/../../plugins/login_booster/states');

var authSuccessState = function(server_auth_response) {
    return new states.AuthSuccess({
        auth: (server_auth_response || _('auth_success').createStanza())
    });
}

module.exports = {
    'it is done': function() {
        assert.isTrue(authSuccessState().done());
    },
    
    'it sends a single response stanza with a success response': function() {
        var server_auth_response = _('auth_success').createStanza();
        var response = authSuccessState(server_auth_response).responseStanzas();
        assert.equal(1, response.length);
        var stanza = _(response).head();
        assert.equal(server_auth_response, stanza);
    },
    
    'popStanza should return undefined': function() {
        assert.isUndefined(authSuccessState().popStanza());
    },

	'it should not restart stream' : function() {
		assert.equal(false, authSuccessState().shouldRestartStream());
	}
}