require(__dirname + '/../test_utils');
var assert = require('assert');
var _ = require('underscore'); 
var states = require(__dirname + '/../../plugins/login_booster/states');

var bindCompleteState = function(bind_response) {
    return new states.BindComplete({
        bind: bind_response || _.createStanza('successful_bind')
    });
}

module.exports = {
    'it is done': function() {
        assert.isTrue(bindCompleteState().done());
    },
    
    'it sends a single response stanza with a success response': function() {
        var bind_response_from_server = _.createStanza('successful_bind');
        var response = bindCompleteState(bind_response_from_server).responseStanzas();
        assert.equal(1, response.length);
        var stanza = _(response).head();
        assert.equal(bind_response_from_server, stanza);
    },
    
    'popStanza should return undefined': function() {
        assert.isUndefined(bindCompleteState().popStanza());
    },

	'it should not restart stream' : function() {
		assert.equal(false, bindCompleteState().shouldRestartStream());
	}
}