require(__dirname + '/../test_utils');
var assert = require('assert');
var _ = require('underscore'); 
var states = require(__dirname + '/../../plugins/login_booster/states');

function preRestartState() {
	return new states.PreRestart();
}

module.exports = {
	'it only changes when stream feature packet is sent from the server': function() {
        var dummy = _('dummy').createStanza();
        var newState = preRestartState().changeUsing(dummy);
		assert.isUndefined(newState);
	},

    'it switches to a Bind state if the stream features includes a bind': function() {
        var stream_features = _('stream_features_with_bind').createStanza();
        var newState = preRestartState().changeUsing(stream_features);
        assert.equal('PreBind', newState.name);
        assert.equal(stream_features, newState._stateData['stream_features']);
    },

   'it is not done': function() {
       assert.equal(false, preRestartState().done()); 
    },
    
    'popStanza should return undefined': function() {
        assert.isUndefined(preRestartState().popStanza());
    },

	'it should restart stream' : function() {
		assert.equal(true, preRestartState().shouldRestartStream());
	},
	
    'it switches to a PreRoster state if the stream features does not include a bind': function() {
       var stream_features = _('stream_features_without_bind').createStanza();
       var newState = preRestartState().changeUsing(stream_features);
       assert.equal('PreRoster', newState.name);
       assert.equal(stream_features, newState._stateData['stream_features']);
    }
}