require(__dirname + '/../test_utils');
var assert = require('assert');
var _ = require('underscore'); 
var states = require(__dirname + '/../../plugins/login_booster/states');

var roomsFetchedState = function() {
    return new states.RoomsFetched({
        rooms: {'plays.shakespeare.lit': _.createStanza('plays_service_items_disco_response')}
    }, 'plays.shakespeare.lit');
}

module.exports = {
    'it is done': function() {
        assert.isTrue(roomsFetchedState().done());
    },
    
    'popStanza should return undefined': function() {
        assert.isUndefined(roomsFetchedState().popStanza());
    },

	'it should not restart stream' : function() {
		assert.equal(false, roomsFetchedState().shouldRestartStream());
	},
    
    'it sends a talk-to rooms response': function() {
        var response = roomsFetchedState().responseStanzas();
        assert.equal(1, response.length);
        var stanza = _(response).head();
        assert.stanzaEqual({
            'iq': {
                '@type': 'set',
                '@id': 'lb_groups_1',
                '@to': 'juliet@example.com/balcony',
                'query': {
                    '@xmlns': 'http://talk.to/x-groups',
                    '#children': [
                        {'item': {
                            '@jid': 'RandJ@chat.shakespeare.lit',
                            '@name': 'Romeo and Juliet',
                        }},
                        {'item': {
                                '@jid': 'maan@chat.shakespeare.lit',
                                '@name': 'Much Ado ABout Nothing'
                        }}
                    ]
                }
            }}, stanza);
    },
}